<?php
namespace Modules\Relatorio\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\Report\Strategy\BirtStrategy;
use Teknisa\Libs\Util\NewCode;


class Gop01600ComparativoOrcamento extends \Zeedhi\Framework\Controller\Report{
    
    protected $birtStrategy;
    protected $newCode;
    protected $environment;
    protected $util;
    protected $service;
    
    public function __construct ($reportService, $birtStrategy, $newCode, $environment, $util, $service) {

        $this->birtStrategy        = $birtStrategy;
        $this->reportService       = $reportService;
        $this->newCode             = $newCode;
        $this->environment         = $environment;
        $this->util                = $util;
        $this->service                = $service;
    }
 
    protected $reportMapping = array (
        'GOP01600' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array(
                        "NRLISTA"       => "P_LFILIAL",
                        "NRLISTAOPER"  => "P_LOPERADOR",
                        "IDPERIODOORCA" => "P_IDPERIODOORCA",
                        "NRPERIODOORCA" => "P_NRPERIODOORCA",
                        "NRANOORCAGOP"  => "P_NRANOORCAGOP",
                        "CONSOLIDADO"   => "P_CONSOLIDADO",
                        "MODELO"        => "P_MODELO",
                        "NRORG"         => "P_NRORG")
            )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $row['__report_name'] = $row['RELATORIO'];
        $row['NRORG'] = $this->environment->getNrorg();
        
        if(is_array($row['CDFILIAL']) && count($row['CDFILIAL'])){
            $units = $row['CDFILIAL'];
        } else {
            $units = $this->service->getUnidades($row);
        }
        $row['NRLISTA'] = $this->util->insertLista($units);
        $row['NRLISTAOPER'] = $this->util->insertLista(array($this->environment->getCdOperador()));

        $this->birtStrategy->setReportFormat($row["ABRIRCOMO"]);
    }
}

