/**********************************************************************/
/* SITE - Sistemas Integrados TECNISA                                 */
/**********************************************************************/
/* Nome: 8694_VMNSTP_Margem_Bruta                                     */
/*                                                                    */
/* Descrio:                                                         */
/*  Calculo Gesto Operacional                                        */
/*                                                                    */
/* Criao:                                                           */
/* 20/01/2003 - Janaina Grazielly C. Hanashiro                        */
/* Manuteno:                                                        */
/* 30/09/2003 - Gustavo Nosseis dos Santos                            */
/**********************************************************************/
/* @C:\Win_V2\Sql\End_Conv\Oracle\8694_VMNSTP_Margem_Bruta            */
/**********************************************************************/

CREATE OR REPLACE PROCEDURE MARGEM_BRUTA_VMN(
P_CDFILIAL      IN SALDOCAIXA.CDFILIAL%TYPE,
P_FILIPROC      IN SALDOCAIXA.CDFILIAL%TYPE,
P_DTINI         IN DATE    ,
P_DTFIN         IN DATE    ,
P_CDFILIALCLIE  IN VARCHAR2,
P_TCDFILIALCLIE IN VARCHAR2,
P_CDEQUIPPRO    IN VARCHAR2,
P_TCDEQUIPPRO   IN VARCHAR2,
P_CDROTATRANS   IN VARCHAR2,
P_TCDROTATRANS  IN VARCHAR2,
P_CDCLIENTE     IN VARCHAR2,
P_TCDCLIENTE    IN VARCHAR2,
P_TIPOCUSTO     IN NUMBER,
P_MARGEMBRUTA   OUT NUMBER )

AS

V_VRTOTALMARGEMBRUTA  NUMBER;
V_CUSTOACUMULADO_AUX  NUMBER;
V_CUSTOACUMULADO      NUMBER;
V_NRPRODUTOS          NUMBER;
V_RESULT              FILIAL.CDFILIAL%TYPE;
V_VRCUSTO             NUMBER;

BEGIN

   V_VRTOTALMARGEMBRUTA := 0;
   V_CUSTOACUMULADO_AUX := 0;
   V_CUSTOACUMULADO     := 0;

   FOR C_PRODUTO IN
       (SELECT VE.CDFILIAL,IT.CDPRODUTO, SUM(NVL(IT.QTPRODVENDA,0)) AS QTPRODVENDA,
               ROUND(NVL(IT.VRUNITVENDA, 0) + NVL(IT.VRUNITVENDAC, 0), 2) AS VRPREBRUTO
        FROM   VENDAVMN VE, ITVENDAVMN IT, MAPABASEV MB
        WHERE
           (TRUNC(VE.DTVENDAVMN) BETWEEN P_DTINI  AND P_DTFIN) AND
           (INSTR(P_CDCLIENTE   , VE.CDCLIENTE   ) <> 0 OR (P_TCDCLIENTE    = 'T')) AND
           (INSTR(P_CDFILIALCLIE, VE.CDFILIALCLIE) <> 0 OR (P_TCDFILIALCLIE = 'T')) AND
           (INSTR(P_CDEQUIPPRO  , MB.CDEQUIPPRO  ) <> 0 OR (P_TCDEQUIPPRO   = 'T')) AND
           (INSTR(P_CDROTATRANS , MB.CDROTATRANS ) <> 0 OR (P_TCDROTATRANS  = 'T')) AND
           (VE.CDFILIAL     = IT.CDFILIAL      ) AND
           (VE.NRVENDA      = IT.NRVENDA       ) AND
           (MB.NRMAPABASEV  = VE.NRMAPABASEV   ) AND
           (VE.IDSITVENDA <> '2'               )
        GROUP BY
           IT.CDPRODUTO, VE.CDFILIAL,
           (NVL(IT.VRUNITVENDA, 0) + NVL(IT.VRUNITVENDAC, 0))
       ORDER BY
          VE.CDFILIAL,IT.CDPRODUTO ) LOOP

      /* VERIFICA COMPOSICAO LOCAL */
      SELECT COUNT(*)
      INTO   V_NRPRODUTOS
      FROM   ROTFABLOCAL
      WHERE (CDFILIAL  = P_CDFILIAL ) AND
            (CDPRODUTO = C_PRODUTO.CDPRODUTO);

      IF V_NRPRODUTOS > 0 THEN
         V_RESULT := P_CDFILIAL;
      ELSE
         V_RESULT := 'P';
      END IF;

      CUSTO_COMP_PROD(C_PRODUTO.CDPRODUTO,'','','',P_TIPOCUSTO,1, V_VRCUSTO);

      V_CUSTOACUMULADO_AUX  := NVL(V_VRCUSTO,0);

      DBMS_OUTPUT.PUT_LINE(C_PRODUTO.CDPRODUTO);
      DBMS_OUTPUT.PUT_LINE((C_PRODUTO.QTPRODVENDA) - (V_VRCUSTO * C_PRODUTO.QTPRODVENDA));
      DBMS_OUTPUT.PUT_LINE(V_VRCUSTO);

      V_CUSTOACUMULADO      := V_CUSTOACUMULADO + (V_CUSTOACUMULADO_AUX * C_PRODUTO.QTPRODVENDA);

      V_VRTOTALMARGEMBRUTA  := V_VRTOTALMARGEMBRUTA + (C_PRODUTO.QTPRODVENDA) - (ROUND(V_CUSTOACUMULADO_AUX,2) * C_PRODUTO.QTPRODVENDA);

      V_CUSTOACUMULADO_AUX  := 0;

   END LOOP;
   P_MARGEMBRUTA := ROUND(V_VRTOTALMARGEMBRUTA,2);
   DBMS_OUTPUT.PUT_LINE(V_VRTOTALMARGEMBRUTA);
END;
/
